#ifndef ONTOLOGY_LEXER_HH
#define ONTOLOGY_LEXER_HH

#include <string>

#include <boost/regex.hpp>

using namespace std;

// ---------- Request parsing  ----------
static const string K_NULL		= "null";
static const string K_ONTOREQ	= QUOTE + "ONTO-REQ" + QUOTE;
static const string K_AGENT		= QUOTE + "AGENT" + QUOTE;
static const string K_OBJECT	= QUOTE + "OBJECT" + QUOTE;
static const string K_PROPERTY	= QUOTE + "PROPERTY" + QUOTE;

static const string AGENT		= K_AGENT + JSEP + STRING;
static const string AGNULL		= K_AGENT + JSEP + K_NULL;
static const string OBJECT		= K_OBJECT + JSEP + STRING;
static const string PROPERTY	= K_PROPERTY + JSEP + STRING;

static const string ONTOFIND	= LSCOPE + K_ONTOREQ + JSEP + LSCOPE + AGNULL + COMMA + OBJECT + COMMA + PROPERTY + RSCOPE + RSCOPE;
static const string ONTOFFA		= LSCOPE + K_ONTOREQ + JSEP + LSCOPE + AGENT + COMMA + OBJECT + COMMA + PROPERTY + RSCOPE + RSCOPE;

// ---------- REGULAR EXPRESSION  ----------
static const boost::regex FindRequest(ONTOFIND);
static const boost::regex FindForAgentRequest(ONTOFFA);

#endif //ONTOLOGY_LEXER_HH
