#include "msgClient.hh"

using namespace std;

msgClient::msgClient() {}

msgClient::~msgClient() {}

bool msgClient::connect(const std::string& name, const std::string& server, unsigned int port) {
	this->isconnected = client.connect(server.c_str(), port);
	if(this->isconnected) {
		this->client.subscribe(name.c_str());
		this->name = name;
		this->s_name = server;
		this->s_port = port;
	}
	return this->isconnected;
}

void msgClient::disconnect() {
	this->isconnected = false;
	client.disconnect();
}

bool msgClient::isConnected() {
	//return this->isconnected;
	return client.isConnected();
} 

bool msgClient::sendMessage(std::string dest, std::string content) { 
	if(this->isConnected()) {
		message msg;
		msg.encode(dest.c_str(), content.c_str());
		return client.send(msg);
	}
	return false;
}

bool msgClient::isMessageWaiting() {
	if(this->isConnected()) {
		return client.checkReadSocket(false);
	}
	return false;
}

pair<string, string> msgClient::getMessage() {
	if(this->isConnected()) {
		std::pair<iclient::received, message> msg = client.receive();
		if(msg.first==iclient::STAT_ERR){
			this->isconnected = false;
			return make_pair("", STATUS_DISCONNECTED);
		}else if(msg.first==iclient::STAT_RECV){
			return make_pair(msg.second.getStringHead(), msg.second.getStringBody()); 
		}
	}
	return make_pair("", STATUS_EMPTY);
}

pair<string, string> msgClient::getBlockingMessage() {
	if(this->isConnected()) {
		if(client.checkReadSocket(true)) return this->getMessage();
	}
	return make_pair("", STATUS_DISCONNECTED);
}

